#
# spec file for package k_numa (Version 2.4.21)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  gpp kernel-source km_afs km_basilisk km_bios km_cipe km_drbd km_drm km_dvb km_ferrari km_ipppcomp km_iscsi km_lirc km_oprofile km_pcmci km_sam9407 km_scsl km_secumod km_v4l2 km_wlan libgpp popt popt-devel
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils cracklib gcc gcc-c++ gdbm gettext kernel-source km_afs km_basilisk km_bios km_cipe km_drbd km_drm km_dvb km_ferrari km_ipppcomp km_iscsi km_lirc km_oprofile km_pcmci km_sam9407 km_scsl km_secumod km_v4l2 km_wlan libstdc++-devel libtool perl popt-devel rpm

Name:         k_numa
Version:      2.4.21
Release:      149
Summary:      Kernel with NUMA support
License:      GPL
Group:        System/Kernel
Provides:     kernel
Requires:     irqbalance
Autoreqprov:  on
PreReq:       mkinitrd /bin/cp /bin/sed /bin/touch /bin/awk
Source0:      config_subst.sh
Source1:      update_rcfile_setting.sh
Source2:      update_INITRD_MODULES.sh
Source3:      readlink.sh
Source4:      relink.sh
Source5:      post.sh
Source6:      postun.sh
Source7:      pre.sh
Source8:      trigger-script.sh.in
%define cfg_name numa
%define ver_str %{version}-%{release}-%{cfg_name}
%define build_km %([ -e %_sourcedir/skip-km ] ; echo $?)
%define strict_preconf 0

%description
Contains optimizations for multi-processor systems with a Non-Uniform
Memory Access (NUMA) architecture, such as AMD x86_64 multi-processor
systems.



%prep
%setup -c -n %name -T
# Updating INITRD_MODULES is only necessary if we want to allow new kernels
# to be installed on old distributions. In all other cases, the current
# mkinitrd will automatically detect which modules are needed in the initrd,
# and will include them.
for when in pre preun post postun ; do
    sed -e "s/@when@/$when/g" %{SOURCE8} > $when.sh
done
cat %{SOURCE7} >> pre.sh
cat %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} %{SOURCE5} >> post.sh
cat %{SOURCE3} %{SOURCE4} %{SOURCE6} >> postun.sh

%build
source %{SOURCE0}
# Create a custom hostname utility and place it in the path before the
# system wide one so that we don't need to create a temporary make file.
export PATH=%_builddir/%buildsubdir:$PATH
cat > %_builddir/%buildsubdir/hostname <<EOF
#! /bin/bash
echo "%_arch.suse.de"
EOF
chmod +x %_builddir/%buildsubdir/hostname
cd /usr/src/linux
make distclean
# These CONFIG_* variables should be set correctly in the defconfig.*
# files already. Update them just to be sure ...
cat arch/%_arch/defconfig.%{cfg_name} \
| config_subst CONFIG_UNITEDLINUX_KERNEL \
| config_subst CONFIG_SUSE_KERNEL y \
| config_subst CONFIG_RELEASE %{release} \
> .config
make oldconfig
if ! make %{?jobs:-j%jobs} dep >  %_tmppath/make-dep.log 2>&1 ; then
    tail -n 1000 %_tmppath/make-dep.log
    exit 1
fi
make %{?jobs:-j%jobs} bzImage
make %{?jobs:-j%jobs} modules
make modules_install
if [ -d /usr/src/linux-%{version}-%{release}-include/%{cfg_name} ]; then
    rm -f /lib/modules/%ver_str/build
    # The kernel headers for this kernel configuration are here ...
    ln -s /usr/src/linux-%{version}-%{release}-include/%{cfg_name} \
	/lib/modules/%ver_str/build
fi
%if %build_km
cd /usr/src
%if %strict_preconf
# The external modules are supposed to locate the kernel sources via
# the /lib/modules/`uname -r`/build symlink. Hide /usr/src/linux and
# /usr/src/linux-%ver_str to ensure that they do.
undo_hide() {
    mv /usr/src/linux-%{version}-%{release}-hidden \
	/usr/src/linux-%{version}-%{release}
    mv /usr/src/linux-hidden /usr/src/linux
}
trap "undo_hide ; exit 1" EXIT
mv /usr/src/linux-%{version}-%{release} \
    /usr/src/linux-%{version}-%{release}-hidden
mv /usr/src/linux /usr/src/linux-hidden
# uname --set-kernel-version %ver_str
echo %ver_str > /.kernelversion
%endif
if [ -d /usr/src/kernel-modules ]; then
    for d in /usr/src/kernel-modules/*; do
	cd $d \
	&& make -f Makefile.module \
	&& make -f Makefile.module install
    done
fi
%if %strict_preconf
undo_hide
trap - EXIT
%endif
%endif

%install
echo -n > %_builddir/%buildsubdir/extra.files
cd /usr/src/linux
mkdir -p /boot
cp -p System.map /boot/System.map-%ver_str
cp -p arch/%_arch/boot/bzImage /boot/vmlinuz-%ver_str
cp -p .config /boot/config-%ver_str
gzip -c9 vmlinux > /boot/vmlinux-%ver_str.gz
if [ -e Kerntypes ] ; then
    cp -p Kerntypes /boot/Kerntypes-%ver_str
    echo /boot/Kerntypes-%ver_str > %_builddir/%buildsubdir/extra.files
fi
# Create a few compatibility links for renamed modules
cd /lib/modules/%ver_str/kernel/drivers/net
ln 3c59x.o 3c90x.o
ln 8139too.o rtl8139.o
cd /lib/modules/%ver_str/kernel/drivers/char
ln hangcheck-timer.o iofence-timer.o
depmod -ae -F /boot/System.map-%ver_str %ver_str
# Ghost files: They are not packed up, and must be created on %post on
# the target system. Ghost symlinks must point to the same target in
# order to not conflict.
rm -f /boot/vmlinuz /boot/initrd
ln -s vmlinuz /boot/vmlinuz
ln -s initrd /boot/initrd
mkdir -p /lib/modules/%{version}-override-%{cfg_name}
mkdir -p /lib/modules/scripts
(   cat <<EOF
/boot/System.map-%ver_str
/boot/vmlinuz-%ver_str
/boot/config-%ver_str
/boot/vmlinux-%ver_str.gz
%ghost /boot/vmlinuz
%ghost /boot/initrd
/lib/modules/%{version}-override-%{cfg_name}
/lib/modules/scripts
EOF
    find /lib/modules/%ver_str \
	-type d -printf '%%%%dir %%p\n' -o \
	-path '*/modules.*' -printf '%%%%verify(not md5 size mtime) %%p\n' -o \
	-printf '%%p\n'
    cat %_builddir/%buildsubdir/extra.files
) > %_builddir/%buildsubdir/all.files
    

%pre -f pre.sh

%preun -f preun.sh

%post -f post.sh

%postun -f postun.sh

%files -f all.files

%changelog -n k_numa
* Tue Sep 23 2003 - aj@suse.de
- Fix provides/obsoletes.
* Fri Sep 19 2003 - agruen@suse.de
- Re-add check of "$1" (number of package instances) to post.sh:
  The check _is_ important, in fact it is essential during initial
  installation.
* Thu Sep 18 2003 - agruen@suse.de
- Another fix in the code that pulls in scsi_mod and sd_mod when
  they are needed. (This wouldn't trigger in all "reasonable"
  situations.)
- Mark files generated by depmod with %%verify(not md5 size mtime).
- Put kernel version string in /.kernelversion (needed for
  %%strict_preconf).
- In the /lib/modules/scripts directory, only try to execute
  regular files.
- Really include Kerntypes if it exists.
- Add %%strict_preconf option (disabled for now): This moves away
  /usr/src/linux and /usr/src/linux-%%ver_str while external
  modules are built. This ensure that they will access the kernel
  sources only via /lib/modules/`uname -r`/build.
- Pass $1 (number of instances of package) to trigger scripts.
- Don't touch /lib/modules/%%ver_str/modules.dep after running the
  %%post trigger scripts. Rather, check if any files below
  /lib/modules/%%ver_str/ are newer than modules.dep, and call
  depmod if so.
- Remove unnecessary check of "$1" (number of package instances)
  from post.sh.
- Make sure no files end up in the files list more than once.
* Wed Sep 17 2003 - agruen@suse.de
- In %%post, call mk_initrd as a fallback to mkinitrd if the latter
  does not exits. If neither of them exists, only print a warning.
* Wed Sep 17 2003 - agruen@suse.de
- Fix CONFIG_DUMP check, and check if the Kerntypes file gets
  created instead. Do so in a way so that the result is still
  available in the %%files section ...
* Wed Sep 17 2003 - agruen@suse.de
- Remove hack with empty.tar.gz with something better.
- Add /boot/Kerntypes-%%ver_str from LKCD whenever it exists.
- Remove xfs_support and xfs_dmapi from INITRD_MODULES if they
  still exist, instead of warning only.
- Make sure scsi_mod and sd_mod are only appended to
  INITRD_MODULES once.
- Fix corruption of /etc/sysconfig/kernel (or /etc/rc.config)
  when INITRD_MODULES is empty in update_rcfile_setting.sh
  (#30310).
- Retain file mode of /etc/sysconfig/kernel (or /etc/rc.config)
  when modifying (#30311).
- Skip building of external modules if the file skip-km exists.
- If pre-configured kernel headers are found, make
  /lib/modules/`uname -r`/build point to them.
- Create directory for kernel override modules.
- Hide output of `make dep', and only print the tail of the
  output if that command fails.
- Add directory /lib/modules/scripts: Upon %%pre, %%preun, %%post,
  and %%postun, each executable in that directory is called in turn
  with $1={--pre|--preun|--post|--postun} and $2=%%ver_str.
  The return values of the scripts are ignored.
- Another fix in the code that pulls in scsi_mod and sd_mod when
  they are needed. (This wouldn't trigger in all "reasonable"
  situations.)
- Re-add kernel configuration file with which the kernel was built.
- Call mkinitrd by its absolute path.
* Thu Sep 04 2003 - sf@suse.de
- require irqbalance [Bug 29885]
* Tue Sep 02 2003 - sf@suse.de
- adopted specfile to i386 to easier merge changes
* Wed Aug 13 2003 - aj@suse.de
- Fix last change.
* Wed Aug 13 2003 - aj@suse.de
- Fix modules dependencies (#28223).
* Thu Jul 31 2003 - aj@suse.de
- Use k_wlan instead of k_atmel.
* Fri Jul 04 2003 - aj@suse.de
- Update to 2.4.21.
* Thu Jun 12 2003 - sf@suse.de
- fix prepare-build.sh
- use make -s
* Thu Jun 12 2003 - sf@suse.de
- use get_release_number.sh
- specfile cleanup
* Tue Jun 10 2003 - ak@suse.de
- fix for new uname
- put changes from kernel-source first
- build with -j2*cpus
* Mon Apr 07 2003 - sf@suse.de
- use config from kernel-source (cvs)
* Mon Mar 31 2003 - aj@suse.de
- Fix provides/obsoletes/conflicts.
* Tue Mar 11 2003 - sf@suse.de
- update config
* Mon Mar 10 2003 - sf@suse.de
- disable CONFIG_NFSD_TCP
* Mon Mar 10 2003 - aj@suse.de
- Update config.
* Thu Mar 06 2003 - sf@suse.de
- added /sbin/mkinitrd to PreReq
* Tue Mar 04 2003 - kukuk@suse.de
- Add PreRequires [Bug #24547]
* Mon Mar 03 2003 - ak@suse.de
- Update config.
* Tue Feb 25 2003 - aj@suse.de
- Update config.
* Sun Feb 23 2003 - aj@suse.de
- Update config.
* Tue Feb 18 2003 - sf@suse.de
- update config
* Fri Feb 14 2003 - aj@suse.de
- Disable it again, it's broken :-(.
* Fri Feb 14 2003 - aj@suse.de
- Enable NUMA ACPI.
* Wed Feb 12 2003 - aj@suse.de
- Enable new options.
* Tue Jan 21 2003 - mantel@suse.de
- enable CONFIG_NET_SCH_HTB
* Sat Jan 18 2003 - mantel@suse.de
- update config; add km_drm for XFree86 4.3
* Wed Jan 15 2003 - kraxel@suse.de
- added km_v4l2 and km_lirc to neededforbuild
* Mon Jan 13 2003 - mantel@suse.de
- update config
* Thu Jan 09 2003 - sf@suse.de
- update .config
* Fri Nov 29 2002 - mantel@suse.de
- run "mkinitrd" after installing the new kernel
* Mon Nov 25 2002 - kkeil@suse.de
- enable build of AVM active card modules
* Thu Oct 31 2002 - ro@suse.de
- fix changelog generation (x-bit for prepare-build.sh)
* Thu Oct 10 2002 - ak@suse.de
- compile RTC in again
* Thu Oct 10 2002 - ak@suse.de
- update for new EVMS
- make RTC modular
- disable debugging (IOMMU,CHECKING) for RC
* Thu Oct 03 2002 - ak@suse.de
- remove km_ferrari, km_basilik, gpp from neededforbuild
- disable speedtouch driver
* Thu Oct 03 2002 - ak@suse.de
- disable wanpipe (64bit problems)
- update
- enable CONFIG_IOMMU_DEBUG
- enable CONFIG_KALLSYMS
* Wed Sep 18 2002 - ak@suse.de
- disable ATM
* Sun Sep 15 2002 - ak@suse.de
- update
* Fri Sep 13 2002 - ak@suse.de
- update
- reenable amd 8111 driver
- enable stack overflow checks and iommu leak tracing (off by default)
* Thu Sep 12 2002 - mantel@suse.de
- fix config
* Mon Sep 09 2002 - mantel@suse.de
- fix config
* Sat Sep 07 2002 - aj@suse.de
- Use NUMA as kernel name following a change in kernel-source.
* Fri Sep 06 2002 - mantel@suse.de
- preserve /boot/vmlinux in RPM for debugging purposes
* Wed Sep 04 2002 - ak@suse.de
- update to latest ACPI changes
* Mon Sep 02 2002 - ak@suse.de
- disable AMD 8111 driver for x86-64
* Sat Aug 31 2002 - ak@suse.de
- sync configuration with i386
- disable some broken drivers (mod_quickcam and meye)
- enable AMD hotplug driver stub
* Wed Aug 28 2002 - ak@suse.de
- Update to new configuration.
* Wed Aug 28 2002 - sf@suse.de
- applied ak's config, only added NUMA
* Thu Aug 22 2002 - sf@suse.de
- removed Intel i8[1234]0 stuff
* Fri Aug 16 2002 - mantel@suse.de
- enable ACL on reiserfs
* Fri Aug 09 2002 - uli@suse.de
- initial package
